using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Transforms {
  /// <summary>
  /// Summary description for Margins.
  /// </summary>
  public class MatrixMarginsForm : System.Windows.Forms.Form {
    /// <summary>
    /// Required designer variable.
    /// </summary>
    private System.ComponentModel.Container components = null;

    public MatrixMarginsForm() {
      //
      // Required for Windows Form Designer support
      //
      InitializeComponent();

      //
      // TODO: Add any constructor code after InitializeComponent call
      //
    }

    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    protected override void Dispose( bool disposing ) {
      if( disposing ) {
        if(components != null) {
          components.Dispose();
        }
      }
      base.Dispose( disposing );
    }

		#region Windows Form Designer generated code
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent() {
      this.statusBar1 = new System.Windows.Forms.StatusBar();
      this.SuspendLayout();
      // 
      // statusBar1
      // 
      this.statusBar1.Location = new System.Drawing.Point(0, 244);
      this.statusBar1.Name = "statusBar1";
      this.statusBar1.Size = new System.Drawing.Size(292, 22);
      this.statusBar1.TabIndex = 0;
      this.statusBar1.Text = "statusBar1";
      // 
      // MatrixMarginsForm
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(292, 266);
      this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                  this.statusBar1});
      this.Name = "MatrixMarginsForm";
      this.Text = "Margins";
      this.Resize += new System.EventHandler(this.MarginsForm_Resize);
      this.Load += new System.EventHandler(this.MatrixMarginsForm_Load);
      this.Paint += new System.Windows.Forms.PaintEventHandler(this.Margins_Paint);
      this.ResumeLayout(false);

    }
		#endregion

    private System.Windows.Forms.StatusBar statusBar1;

    String s = "For example, its not important that the ruler at the top of the document Im typing this sentence into is currently showing an inch as 1 9/16 inches. What is important is the proportion of the dimensions of each line in proportion to the units shown as inches as compared to the width and height of each line as I type. The principle of WYSIWYG (What You See Is What You Get) says that I should be able to print something very similar to what Im seeing on the screen . When my word processing program shows a line wrapping at a certain word when I get close to the 6  inches area inside of my margins (my page settings are set to standard 8  inch wide paper with a 1 inch margin on each side), I want that same wrap to happen at the same word when I print. To make that happen, we need to be able to write a program that can wrap text at units other than pixels, as shown in Figure 1.";

    float InchesToPixels(float inches) {
      using( Graphics g = this.CreateGraphics() ) {
        return inches * g.DpiY;
      }
    }

    RectangleF InchesToPixels(RectangleF rect) {
      return new RectangleF(InchesToPixels(rect.X), InchesToPixels(rect.Y), InchesToPixels(rect.Width), InchesToPixels(rect.Height));
    }

    float PixelsToInches(float pixels) {
      using( Graphics g = this.CreateGraphics() ) {
        return pixels / g.DpiY;
      }
    }

    void PaintInInches(Graphics g) {
      // Set units to inches using a transform
      Matrix matrix = new Matrix();
      matrix.Scale(g.DpiX, g.DpiY);
      g.Transform = matrix;

      using( Font rulerFont = new Font("MS Sans Serif", 8.25f / g.DpiY) )
      using( Pen blackPen = new Pen(Color.Black, 0) ) {
        float rulerFontHeight = rulerFont.GetHeight(g); // Inches
        // Specifiy units in inches
        RectangleF rulerRect =
          new RectangleF(
          0, 0,
          6.5f, rulerFontHeight * 1.5f);
        // Draw in inches
        g.DrawRectangle(
          blackPen,
          rulerRect.X, rulerRect.Y,
          rulerRect.Width, rulerRect.Height);

        // Draw 6.5 inches in inches
        for( float i = 1; i <= 6; ++i ) {
          // Specify units in inches
          RectangleF rect = new RectangleF(i - rulerFontHeight, 0, rulerFontHeight * 2, rulerFontHeight);
          StringFormat format = new StringFormat();
          format.Alignment = StringAlignment.Center;
          g.DrawString(i.ToString(), rulerFont, Brushes.Black, rect, format);
          //g.DrawLine(blackPen, i, 0, i, rulerFontHeight/2);
        }

        // Draw 6.5 inches in half inches
        for( float i = 0.5f; i <= 6.5f; i += 1.0f ) {
          g.DrawLine(blackPen, i, 0, i, rulerFontHeight/2);
        }

        using( Font textFont = new Font("Times New Roman", 11f / g.DpiY) ) {
          // Draw text wrapped to 6.5 inch margin
          RectangleF textRect = new RectangleF(0, rulerRect.Height, 6.5f, PixelsToInches(this.ClientRectangle.Height) - rulerRect.Height);
          g.FillRectangle(Brushes.White, textRect);
          g.DrawRectangle(blackPen, textRect.X, textRect.Y, textRect.Width, textRect.Height);
          g.DrawString(s, textFont, Brushes.Black, textRect);
        }
      }

    }

    // TODO: Remove
    public void ScaleExample(PaintEventArgs e) {
      Pen myPen = new Pen(Color.Blue, 1);
      Pen myPen2 = new Pen(Color.Red, 1);
      // Draw the rectangle to the screen before applying the
      // transform.
      e.Graphics.DrawRectangle(myPen, 50, 50, 100, 100);
      // Create a matrix and scale it.
      Matrix myMatrix = new Matrix();
      myMatrix.Scale(3, 2, MatrixOrder.Append);
      // Draw the rectangle to the screen again after applying the
      // transform.
      e.Graphics.Transform = myMatrix;
      e.Graphics.DrawRectangle(myPen2, 50, 50, 100, 100);
    }
    
    void Margins_Paint(object sender, PaintEventArgs e) {
      PaintInInches(e.Graphics);
      //ScaleExample(e);
    }

    void ShowClientSize() {
      using( Graphics g = this.CreateGraphics() ) {
        // Set units to inches using a transform
        Matrix matrix = new Matrix();
        matrix.Scale(g.DpiX, g.DpiY);
        g.Transform = matrix;

        PointF[] bottomRight =
          new PointF[] { new PointF(this.ClientSize.Width, this.ClientSize.Height) };
        // Convert client size from pixels to inches
        g.TransformPoints(
          CoordinateSpace.World, CoordinateSpace.Device, bottomRight);
        statusBar1.Text = string.Format("ClientSize= {0} pixels, {1} inches", this.ClientSize, bottomRight[0]);
      }
    }

    void MarginsForm_Resize(object sender, EventArgs e) {
      ShowClientSize();
    }

    private void MatrixMarginsForm_Load(object sender, System.EventArgs e) {
      ShowClientSize();
    }

  }
}












